chiark / gitweb /
changelog: start 9.14
[dgit.git] / tests / lib
index 3a5b29f432e4567137451bbe8116a3363f2749c5..749509c4fc240d301d77cb56c8d33adbb263362d 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -22,7 +22,23 @@ END
        exit 16
 }
 
-trap 'test $? = 0 || t-report-failure' EXIT
+trap '
+       rc=$?
+       set +x
+       test $rc = 0 || echo "
+%%%%%%%%%%%%%%%%%%%% EXITING $rc %%%%%%%%%%%%%%%%%%%%
+
+               Most relevant logs are just before assignment rc=$rc
+               Will now do cleanup etc.
+"
+       set -x
+       set +e
+       pwd
+       [ "x$DGIT_TEST_KEEP_MUSTCLEAN" != x ] || \
+       [ "x$DGIT_TEST_TMP" = x ] || rm -rf $DGIT_TEST_TMP/must-clean
+       set -e
+       test $rc = 0 || t-report-failure
+' EXIT
 
 t-filter-out-git-hyphen-dir
 
@@ -74,6 +90,11 @@ export DEBCHANGE_VENDOR=dpkg
 unset VISUAL
 unset GIT_EDITOR
 
+mkdir -p $tmp/must-clean
+# must-clean is usually removed after each test, on success or failure.
+# But this must not be relied on for correctness, only for garbage
+# collection etc.
+
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
 [test-dummy]
@@ -350,7 +371,8 @@ t-archive () {
        v=$2
        local dscf=${p}_$2.dsc
        rm -f $tmp/mirror/pool/main/${p}_*
-       ln -s $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
+       ${t_archive_ln_s-ln -s} \
+                $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
        t-archive-query $suite
        rm -rf $tmp/extract
        mkdir $tmp/extract
@@ -464,6 +486,19 @@ t-dgit () {
 '
 }
 
+t-non-dgit-upload () {
+       t-dgit -wgf build-source
+
+       cd ..
+       c=${p}_${v}_source.changes
+       debsign -kBCD22CD83243B79D3DFAC33EA3DBCBC039B13D8A $c
+       dput -c $tmp/dput.cf test-dummy $c
+
+       t-archive-process-incoming sid
+       t-git-next-date
+       cd $p
+}
+
 t-dgit-manpage () {
        local section=$1
        local page=$2
@@ -573,6 +608,8 @@ t-setup-import () {
                (set -e; cd $tmp; tar xf "$simport.tar")
        fi
 
+       mkdir -p $tmp/must-clean
+
        . "$simport"
 }
 
@@ -777,11 +814,12 @@ t-splitbrain-pushed-good-start () {
 
        t-refs-same-start
        t-ref-same refs/heads/split.p
-       case "$(t-git-get-ref refs/heads/split.b)" in
+       local split_b=$(t-git-get-ref refs/heads/split.b)
+       case "$split_b" in
        "$t_ref_val") ;;
        "$(git rev-parse refs/heads/split.p^0)") ;;
        "$(git rev-parse refs/heads/split.p^1)") ;;
-       *) fail 'bad b/p' ;;
+       *) fail "bad b/p (b=$split_b)" ;;
        esac
        t-pushed-good-core
 
@@ -1027,7 +1065,6 @@ t-git-pseudo-merge () {
 }
 
 t-gbp-example-prep-no-ff () {
-       t-tstunt-parsechangelog
        t-archive example 1.0-1
        t-git-none
        t-worktree 1.0
@@ -1187,7 +1224,7 @@ t-debpolicy () {
        t-dsd
        t-policy dgit-repos-policy-debian
 
-       mkdir $tmp/git
+       mkdir -p $tmp/git
        t-policy-admin create-db
 }